'''
Created on Sep 18, 2015

@author: scrosby
'''
import datetime

class HistoryStats:
    
    def __init__(self, history):
        self.history = history
        
    def __convert_to_time__(self, time):
        TIME_FORMAT="%Y-%m-%dT%H:%M:%S.000+0000"
        return datetime.datetime.strptime(time, TIME_FORMAT)
    
    def __record_create_time__(self, record):
        return self.__convert_to_time__(record['CreatedDate'])
    
    def __hour_delta__(self, start, end):
        hours = None
        if start and end:
            
            difference = end - start
            hours = divmod(difference.total_seconds(), 3600)[0]
        return hours
    
    def __first_value_time__(self, status):   
        for record in self.history:
            if record['NewValue'] == status:
                return self.__record_create_time__(record)
            
        return None
    
    def __last_value_time__(self, status):
        out = None
        for record in self.history:
            if record['NewValue'] == status:
                out = self.__record_create_time__(record)
                
        return out
                